package com.java2s.common;

import java.util.Collection;
import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.springframework.transaction.annotation.Transactional;

@Transactional
public class PersonDaoImpl {
  public void test() {
    Employee emp = new Employee();
    emp.setName("Tom");
    emp.setSalary(123);
    emp.setStartDate(new Date());
    emp.setId(1);

    Project pro = new Project();
    pro.setName("Design");
    pro.getEmployees().add(emp);

    Department dept = new Department();
    dept.setName("Dept");
    dept.getEmployees().add(emp);

    emp.setDepartment(dept);
    emp.getProjects().add(pro);

    em.persist(dept);
    em.persist(pro);
    em.persist(emp);

    String deptName = "Dept";
    String empName = "Tom";

    List l = em.createQuery("SELECT e " +
            "FROM Project p JOIN p.employees e " +
            "WHERE p.name = :project " +
            "ORDER BY e.name")
            .setParameter("project", "Design")
            .getResultList();


     System.out.println(l);

  }
  private String reportQueryName;
  private int currentPage;
  private int maxResults;
  private int pageSize;
  
  public int getPageSize() {
      return pageSize;
  }
  
  public int getMaxPages() {
      return maxResults / pageSize;
  }

  public void init(int pageSize, String countQueryName, 
                   String reportQueryName) {
      this.pageSize = pageSize;
      this.reportQueryName = reportQueryName;
      maxResults = ((Long) em.createNamedQuery(countQueryName)
                                  .getSingleResult()).intValue();
      currentPage = 0;
  }
  
  public List getCurrentResults() {
      return em.createNamedQuery(reportQueryName)
               .setFirstResult(currentPage * pageSize)
               .setMaxResults(pageSize)
               .getResultList();
  }
  
  public void next() {
      currentPage++;
  }
  
  public void previous() {
      currentPage--;
      if (currentPage < 0) {
          currentPage = 0;
      }
  }
  
  public int getCurrentPage() {
      return currentPage;
  }
  
  public void setCurrentPage(int currentPage) {
      this.currentPage = currentPage;
  }
  
  @PersistenceContext
  private EntityManager em;
}
